var Abonnement = function() {

    var _this;

    return {
        initConfig: function()
        {
            _this.config = {};
        },

        initElements: function()
        {
            _this.$elements = {
                'checkStatus'     : $('.input-status'),
                'contentDiv'      : $('#content-div'),
                'toolBox'         : $('.btn-box-tool'),
                'flashContent'    : $('.message-content'),
                // 'inputNotRequired': $('.not-required')
            };

            _this.$elements.toolBox.click();
            // _this.$elements.inputNotRequired.removeAttr('required');
        },

        bindElements: function()
        {
            _this.$elements.checkStatus
                .off('change')
                .on('change', function(){
                    $.ajax({
                        'url'     : Routing.generate('admin_pack_change_status', {'id':$(this).data('id')}),
                        'type'    : 'POST',
                        'dataType': 'json',
                    }).always(function(response) {
                        _this.$elements.flashContent.html('');
                        if (typeof response.notif != 'undefined') {
                            _this.setFlashMessage(response);
                        }
                    });
                });
            ;
        },

        setFlashMessage : function(response)
        {
            var $msg        = response.notif.message;
            var $typeAlert  = 'danger';
            if('success' == response.notif.kind){
                $typeAlert  = 'success';
            }
            var $html = '<div class="alert alert-'+$typeAlert+' alert-dismissable message-content">'+
                                '<a href="#" class="close" data-dismiss="alert" aria-label="close">×</a>'+
                                $msg+
                        '</div>';

            _this.$elements.contentDiv.prepend($html);
        },

        init: function()
        {
            _this = this;
            _this.initConfig();
            _this.initElements();
            _this.bindElements();
        }
    };

}();
