function initShare() {
    window.downloadFile = function (sUrl) {
        //iOS devices do not support downloading. We have to inform user about this.
        if (/(iP)/g.test(navigator.userAgent)) {
            //alert('Your device does not support files downloading. Please try again in desktop browser.');
            window.open(sUrl, '_blank');
            return false;
        }

        //If in Chrome or Safari - download via virtual link click
        if (window.downloadFile.isChrome || window.downloadFile.isSafari) {
            //Creating new link node.
            var link = document.createElement('a');
            link.href = sUrl;
            link.setAttribute('target', '_blank');

            if (link.download !== undefined) {
                //Set HTML5 download attribute. This will prevent file from opening if supported.
                var fileName = sUrl.substring(sUrl.lastIndexOf('/') + 1, sUrl.length);
                link.download = fileName;
            }

            //Dispatching click event.
            if (document.createEvent) {
                var e = document.createEvent('MouseEvents');
                e.initEvent('click', true, true);
                link.dispatchEvent(e);
                return true;
            }
        }

        // Force file download (whether supported by server).
        if (sUrl.indexOf('?') === -1) {
            sUrl += '?download';
        }

        window.open(sUrl, '_blank');
        return true;
    }

    window.downloadFile.isChrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
    window.downloadFile.isSafari = navigator.userAgent.toLowerCase().indexOf('safari') > -1;


    var fbShareManager = {
        id: "",
        title: "",
        url: "",
        username: "",
        description: "",
        image: ""
    };

    $('.music-download').off('click').click(function () {
        $('#btnShareTwitter').html("");
        fbShareManager.id = $(this).data("id");
        fbShareManager.title = $(this).data("title");
        fbShareManager.url = $(this).data("url");
        fbShareManager.image = $(this).data("image");
        fbShareManager.description = $(this).data("description");
        fbShareManager.username = $(this).data("username");

        $("#btnShareG").attr("href", "https://plus.google.com/share?url=" + fbShareManager.url);
        $('#modalShare').modal('show');

        twttr.events.bind(
            'tweet',
            function (event) {
                window.downloadFile(Routing.generate('music_dowload', {
                    id: fbShareManager.id,
                    _locale: local
                }));
            }
        );

        twttr.widgets.createShareButton(
            '/',
            document.getElementById('btnShareTwitter'), {
                text: fbShareManager.title + ' ' + fbShareManager.url,
                url: fbShareManager.url,
                hashtags: fbShareManager.username,
                via: 'Allbeats'
            }
        );
    });

    $("#btnShareG").off('click').click(function () {
        setTimeout(function () {
            window.downloadFile(Routing.generate('music_dowload', {
                id: fbShareManager.id,
                _locale: local
            }));
        }, 12000);
    });

    $('#btnShareFb').off('click').click(function () {
        FB.ui({
            method: 'feed',
            link: fbShareManager.url,
            caption: fbShareManager.title,
            picture: fbShareManager.image
        }, function (response) {
            if (response) {
                window.downloadFile(Routing.generate('music_dowload', {
                    id: fbShareManager.id,
                    _locale: local
                }));
            }
        });
    });
}

initShare();