(function () {
    "use strict";
    var sondageContentHtml = $('<div id="sondage" style="position: fixed; z-index: 999; bottom: 70px; border-radius: 4px; right: 20px; min-height: 150px; width: 300px; color: white; padding: 10px 15px; background: #222;"></div>');
    sondageContentHtml.append('<h6>' + sondageTitle + '</h6>');
    sondageContentHtml.append('<p><small> ' + sondageText + ' </small></p>');
    sondageContentHtml.append('<div style="display: flex; margin-bottom: 7px;"><div data-id="0" class="emoticon"><img src="https://png.icons8.com/sad/color/28/666666"></div> <div data-id="1" class="emoticon"><img src="https://png.icons8.com/neutral/color/28/666666"></div> <div data-id="2" class="emoticon"><img src="https://png.icons8.com/happy/color/28/666666"></div> <div data-id="3" class="emoticon"><img src="https://png.icons8.com/cool/color/28/666666"></div></div>')
    sondageContentHtml.append('<textarea style="margin-bottom: 7px;" class="form-control" style="width: 100%;"></textarea>')
    sondageContentHtml.append('<button class="btn btn-sm btn-primary btn-send">' + sondageSend + '</button> <button class="btn btn-sm btn-default btn-close">' + sondageNotNow + '</button>')
    $(document).ready(function () {
        if (!isAnswred()) {
            if (userConnected) {
                $.ajax({
                    type: "GET",
                    url: Routing.generate('answered_sondage', {
                        _locale: local
                    }),
                    dataType: "JSON",
                    success: function (response) {
                        if (!response.answered) {
                            $('html').append(sondageContentHtml);
                            styleView();
                            actionView();
                        }
                    }
                });
            } else {
                $('html').append(sondageContentHtml);
                styleView();
                actionView();
            }
        }
    });
    function styleView() {
        $('.emoticon').css({
            "margin-right": "10px",
            "border-radius": "4px",
            "cursor": "pointer"
        });
        $('.emoticon').click(function (e) {
            $('.emoticon').removeClass("selected");
            $('.emoticon').css("background", "inherit");

            $(this).addClass("selected");
            $(this).css("background", "#6CC74F");
        });
    }
    function actionView() {
        $('.btn-send').click(function (e) {
            $.ajax({
                type: "POST",
                url: Routing.generate('send_sondage', {
                    _locale: local
                }),
                data: {
                    mood: $('.emoticon.selected').data('id'),
                    content: $('#sondage textarea').val()
                },
                dataType: "JSON",
                success: function (response) {
                    window.localStorage.setItem('sondageanswered', "sended");
                }
            });
            close();
        });

        $('.btn-close').click(function (e) {
            window.localStorage.setItem('sondageanswered', "sended");
            close();
        });
    }
    function close() {
        $("#sondage").remove();
    }
    function isAnswred() {
        return window.localStorage.getItem('sondageanswered');
    }
})();