$("#acceptCondition").change(function () {
    $("#payment-not-allowed").attr("hidden", $(this).is(":checked"));
});

$(document).ready(function () {
    if (typeof paypal != "undefined") {
        paypal.Button.render({
            env: env, // Optional: specify 'sandbox' ('production') environment
            locale: 'fr_FR',
            payment: function () {
                var env = this.props.env;
                var client = this.props.client;
                return paypal.rest.payment.create(env, client, {
                    transactions: [
                        {
                            amount: { total: parseFloat(cartManager.getPrice().toFixed(2)), currency: 'EUR' }
                        }
                    ]
                });
            },
            commit: true,
            client: {
                sandbox: paypal_client_id_sandbox,
                production: paypal_client_id
            },
            onAuthorize: function (data, actions) {
                return actions.payment.execute().then(function () {
                    addCache();
                    cartManager.clear();
                    $("#modalPaiement").modal("hide");
                    $("#validateCartBtn").trigger("click");
                });
            }
        }, '#paypal-button');

    }
});